<template>
    <div id="app">
        <div class="filter-overlay"></div>
        <b-navbar>
            <template #brand>
                <b-navbar-item tag="router-link" :to="{ path: '/' }">
                    <img
                        src="./assets/ssai-logo.png"
                        alt="SSAI logo"
                    >
                </b-navbar-item>
            </template>
            <template #start>
               <b-navbar-item tag="router-link" :to="{ path: '/scoreboard' }">
                   Scoreboard
               </b-navbar-item>
               <b-navbar-item tag="router-link" :to="{ path: '/contestant-portal' }">
                   Contestant Portal
               </b-navbar-item>
            </template>
            <template #end>
                <b-navbar-item tag="div">
                    <div class="buttons">
                        <b-button v-if="!isLoggedIn" type="is-primary" tag="router-link" to="/register">
                            Register
                        </b-button>
                        <b-button v-else type="is-info is-dark" tag="router-link" to="/profile">
                            Profile
                        </b-button>
                        <b-button type="is-primary is-light" @click="loginAction">
                            {{ loginButtonMessage }}
                        </b-button>
                    </div>
                </b-navbar-item>
            </template>
        </b-navbar>
        
        <router-view
            class="router"
            @login="isLoggedIn = true"
        ></router-view>
        <footer class="footer">
            <div class="content">
                <div class="has-text-centered block">
                    <a href="https://www.afrl.af.mil/">
                        <img
                            class="footer-logo"
                            alt="AFRL world logo"
                            src="./assets/afrl_world.png"
                        >
                    </a>
                    <a href="https://www.gov.uk/government/organisations/defence-science-and-technology-laboratory">
                        <img
                            class="footer-logo"
                            alt="DSTL logo"
                            src="./assets/dstl.png"
                        >
                    </a>
                    <a href="https://www.wbi-innovates.com/">
                        <img
                            class="footer-logo"
                            alt="WBI logo"
                            src="./assets/wbi_logo.png"
                        >
                    </a>
                    <a href="https://gtri.gatech.edu/">
                        <img
                            class="footer-logo"
                            alt="GTRI logo"
                            src="./assets/gtri_logo.png"
                        >
                    </a>
                </div>
                <div class="has-text-centered">
                    <p>
                    <a href="https://www.labhack.org/t&c/">Terms and Conditions&nbsp;&nbsp;&nbsp;&nbsp;|</a>
                    <a href="https://www.gatech.edu/privacy">&nbsp;&nbsp;&nbsp;&nbsp;Privacy Policy&nbsp;&nbsp;&nbsp;&nbsp;|</a>
                    <a href="mailto:bob.lee@wbi-innovates.com">&nbsp;&nbsp;&nbsp;&nbsp;Contact Us&nbsp;&nbsp;&nbsp;&nbsp;|</a>
                    <a href="https://www.labhack.org/index">&nbsp;&nbsp;&nbsp;&nbsp;Return to LabHack.org</a>
                </p>
            </div>
            </div>
        </footer>
    </div>
</template>

<script>
 export default {
     name: 'App',
     computed: {
         loginButtonMessage() {
             return this.isLoggedIn ? "Log out" : "Log in"
         }
     },
     mounted() {
         this.checkLoggedIn()
     },
     data() {
         return {
             publicPath: process.env.BASE_URL,
             isLoggedIn: false
         }
     },
     methods: {
         loginAction() {
             if (this.isLoggedIn) {
                 // do logout
                 this.isLoggedIn = false
                 fetch('/api/user/logout')
                 this.$router.push('/')
             } else {
                 // do login
                 this.$router.push('/login')
             }
         },
         checkLoggedIn() {
             fetch('/api/user/authed')
                 .then((response) => {
                     if (response.status === 200) {
                         this.isLoggedIn = true
                     } else if (response.status === 401) {
                         this.isLoggedIn = false
                     }
                 })
                 .catch((e) => {
                     console.error(e);
                     this.$buefy.toast.open({
                         duration: 5000,
                         message: 'Something went wrong',
                         position: 'is-bottom',
                         type: 'is-danger'
                     })
                 })
         }
     }
 }
</script>
<style scoped>
 .router {
     min-height: calc(100vh - 7rem);
 }
</style>
